]> git.saurik.com Git - apt.git/blob - test/integration/framework
simple URI rewrite rules config for webserver
[apt.git] / test / integration / framework
1 #!/bin/sh -- # no runable script, just for vi
2
3 EXIT_CODE=0
4
5 # we all like colorful messages
6 if expr match "$(readlink -f /proc/$$/fd/1)" '/dev/pts/[0-9]\+' > /dev/null && \
7 expr match "$(readlink -f /proc/$$/fd/2)" '/dev/pts/[0-9]\+' > /dev/null; then
8 CERROR="\e[1;31m" # red
9 CWARNING="\e[1;33m" # yellow
10 CMSG="\e[1;32m" # green
11 CINFO="\e[1;96m" # light blue
12 CDEBUG="\e[1;94m" # blue
13 CNORMAL="\e[0;39m" # default system console color
14 CDONE="\e[1;32m" # green
15 CPASS="\e[1;32m" # green
16 CFAIL="\e[1;31m" # red
17 CCMD="\e[1;35m" # pink
18 fi
19
20 msgdie() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; }
21 msgwarn() { echo "${CWARNING}W: $1${CNORMAL}" >&2; }
22 msgmsg() { echo "${CMSG}$1${CNORMAL}" >&2; }
23 msginfo() { echo "${CINFO}I: $1${CNORMAL}" >&2; }
24 msgdebug() { echo "${CDEBUG}D: $1${CNORMAL}" >&2; }
25 msgdone() { echo "${CDONE}DONE${CNORMAL}" >&2; }
26 msgnwarn() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; }
27 msgnmsg() { echo -n "${CMSG}$1${CNORMAL}" >&2; }
28 msgninfo() { echo -n "${CINFO}I: $1${CNORMAL}" >&2; }
29 msgndebug() { echo -n "${CDEBUG}D: $1${CNORMAL}" >&2; }
30 msgtest() {
31 while [ -n "$1" ]; do
32 echo -n "${CINFO}$1${CCMD} " >&2;
33 echo -n "$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} " >&2;
34 shift
35 if [ -n "$1" ]; then shift; else break; fi
36 done
37 echo -n "…${CNORMAL} " >&2;
38 }
39 msgpass() { echo "${CPASS}PASS${CNORMAL}" >&2; }
40 msgskip() { echo "${CWARNING}SKIP${CNORMAL}" >&2; }
41 msgfail() { echo "${CFAIL}FAIL${CNORMAL}" >&2; EXIT_CODE=$((EXIT_CODE+1)); }
42
43 # enable / disable Debugging
44 MSGLEVEL=${MSGLEVEL:-3}
45 if [ $MSGLEVEL -le 0 ]; then
46 msgdie() { true; }
47 fi
48 if [ $MSGLEVEL -le 1 ]; then
49 msgwarn() { true; }
50 msgnwarn() { true; }
51 fi
52 if [ $MSGLEVEL -le 2 ]; then
53 msgmsg() { true; }
54 msgnmsg() { true; }
55 msgtest() { true; }
56 msgpass() { echo -n " ${CPASS}P${CNORMAL}" >&2; }
57 msgskip() { echo -n " ${CWARNING}S${CNORMAL}" >&2; }
58 if [ -n "$CFAIL" ]; then
59 msgfail() { echo -n " ${CFAIL}FAIL${CNORMAL}" >&2; }
60 else
61 msgfail() { echo -n " ###FAILED###" >&2; }
62 fi
63 fi
64 if [ $MSGLEVEL -le 3 ]; then
65 msginfo() { true; }
66 msgninfo() { true; }
67 fi
68 if [ $MSGLEVEL -le 4 ]; then
69 msgdebug() { true; }
70 msgndebug() { true; }
71 fi
72 msgdone() {
73 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
74 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
75 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
76 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
77 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
78 true;
79 else
80 echo "${CDONE}DONE${CNORMAL}" >&2;
81 fi
82 }
83
84 runapt() {
85 msgdebug "Executing: ${CCMD}$*${CDEBUG} "
86 if [ -f ./aptconfig.conf ]; then
87 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
88 elif [ -f ../aptconfig.conf ]; then
89 APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
90 else
91 LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
92 fi
93 }
94 aptconfig() { runapt apt-config $*; }
95 aptcache() { runapt apt-cache $*; }
96 aptcdrom() { runapt apt-cdrom $*; }
97 aptget() { runapt apt-get $*; }
98 aptftparchive() { runapt apt-ftparchive $*; }
99 aptkey() { runapt apt-key $*; }
100 aptmark() { runapt apt-mark $*; }
101 dpkg() {
102 $(which dpkg) --root=${TMPWORKINGDIRECTORY}/rootdir --force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log $*
103 }
104 aptitude() {
105 if [ -f ./aptconfig.conf ]; then
106 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
107 elif [ -f ../aptconfig.conf ]; then
108 APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
109 else
110 LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
111 fi
112 }
113 gdb() {
114 echo "gdb: run »$*«"
115 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which gdb) ${BUILDDIRECTORY}/$1
116 }
117
118 exitwithstatus() {
119 # error if we about to overflow, but ...
120 # "255 failures ought to be enough for everybody"
121 if [ $EXIT_CODE -gt 255 ]; then
122 msgdie "Total failure count $EXIT_CODE too big"
123 fi
124 exit $((EXIT_CODE <= 255 ? EXIT_CODE : 255));
125 }
126
127 addtrap() {
128 if [ "$1" = 'prefix' ]; then
129 CURRENTTRAP="$2 $CURRENTTRAP"
130 else
131 CURRENTTRAP="$CURRENTTRAP $1"
132 fi
133 trap "$CURRENTTRAP exitwithstatus;" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
134 }
135
136 setupenvironment() {
137 TMPWORKINGDIRECTORY=$(mktemp -d)
138 TESTDIRECTORY=$(readlink -f $(dirname $0))
139 msgninfo "Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
140 BUILDDIRECTORY="${TESTDIRECTORY}/../../build/bin"
141 test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first"
142 addtrap "cd /; rm -rf $TMPWORKINGDIRECTORY;"
143 cd $TMPWORKINGDIRECTORY
144 mkdir rootdir aptarchive keys
145 cd rootdir
146 mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d
147 mkdir -p var/cache var/lib var/log
148 mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers
149 touch var/lib/dpkg/available
150 mkdir -p usr/lib/apt
151 ln -s ${BUILDDIRECTORY}/methods usr/lib/apt/methods
152 cd ..
153 local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
154 if [ -f "${TESTDIRECTORY}/${PACKAGESFILE}" ]; then
155 cp "${TESTDIRECTORY}/${PACKAGESFILE}" aptarchive/Packages
156 fi
157 local SOURCESSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
158 if [ -f "${TESTDIRECTORY}/${SOURCESSFILE}" ]; then
159 cp "${TESTDIRECTORY}/${SOURCESSFILE}" aptarchive/Sources
160 fi
161 cp $(find $TESTDIRECTORY -name '*.pub' -o -name '*.sec') keys/
162 ln -s ${TMPWORKINGDIRECTORY}/keys/joesixpack.pub rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
163 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
164 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
165 echo "Debug::NoLocking \"true\";" >> aptconfig.conf
166 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
167 echo "Dir::Bin::Methods \"${BUILDDIRECTORY}/methods\";" >> aptconfig.conf
168 echo "Dir::Bin::dpkg \"fakeroot\";" >> aptconfig.conf
169 echo "DPKG::options:: \"dpkg\";" >> aptconfig.conf
170 echo "DPKG::options:: \"--root=${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf
171 echo "DPKG::options:: \"--force-not-root\";" >> aptconfig.conf
172 echo "DPKG::options:: \"--force-bad-path\";" >> aptconfig.conf
173 if ! $(which dpkg) --assert-multi-arch 2>&1 > /dev/null; then
174 echo "DPKG::options:: \"--force-architecture\";" >> aptconfig.conf # Added to test multiarch before dpkg is ready for it…
175 fi
176 echo "DPKG::options:: \"--log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log\";" >> aptconfig.conf
177 echo 'quiet::NoUpdate "true";' >> aptconfig.conf
178 export LC_ALL=C
179 export PATH="${PATH}:/usr/local/sbin:/usr/sbin:/sbin"
180 msgdone "info"
181 }
182
183 getarchitecture() {
184 if [ "$1" = "native" -o -z "$1" ]; then
185 eval `aptconfig shell ARCH APT::Architecture`
186 if [ -n "$ARCH" ]; then
187 echo $ARCH
188 else
189 dpkg --print-architecture
190 fi
191 else
192 echo $1
193 fi
194 }
195
196 getarchitectures() {
197 echo "$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
198 }
199
200 configarchitecture() {
201 local CONFFILE=rootdir/etc/apt/apt.conf.d/01multiarch.conf
202 rm -f $CONFFILE
203 echo "APT::Architecture \"$(getarchitecture $1)\";" > $CONFFILE
204 shift
205 while [ -n "$1" ]; do
206 echo "APT::Architectures:: \"$(getarchitecture $1)\";" >> $CONFFILE
207 shift
208 done
209 configdpkg
210 }
211
212 configdpkg() {
213 if [ ! -e rootdir/var/lib/dpkg/status ]; then
214 local STATUSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
215 if [ -f "${TESTDIRECTORY}/${STATUSFILE}" ]; then
216 cp "${TESTDIRECTORY}/${STATUSFILE}" rootdir/var/lib/dpkg/status
217 else
218 echo -n > rootdir/var/lib/dpkg/status
219 fi
220 fi
221 if $(which dpkg) --assert-multi-arch 2>&1 > /dev/null; then
222 local ARCHS="$(getarchitectures)"
223 if echo "$ARCHS" | grep -E -q '[^ ]+ [^ ]+'; then
224 DPKGARCH="$(dpkg --print-architecture)"
225 for ARCH in ${ARCHS}; do
226 if [ "${ARCH}" != "${DPKGARCH}" ]; then dpkg --add-architecture ${ARCH}; fi
227 done
228 if [ "0" = "$(dpkg -l dpkg 2> /dev/null | grep '^i' | wc -l)" ]; then
229 # dpkg doesn't really check the version as long as it is fully installed,
230 # but just to be sure we choose one above the required version
231 insertinstalledpackage 'dpkg' "all" '1.16.2+fake'
232 fi
233 fi
234 fi
235 }
236
237 setupsimplenativepackage() {
238 local NAME="$1"
239 local ARCH="$2"
240 local VERSION="$3"
241 local RELEASE="${4:-unstable}"
242 local DEPENDENCIES="$5"
243 local DESCRIPTION="$6"
244 local SECTION="${7:-others}"
245 local DISTSECTION
246 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
247 DISTSECTION="main"
248 else
249 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
250 fi
251 local BUILDDIR=incoming/${NAME}-${VERSION}
252 mkdir -p ${BUILDDIR}/debian/source
253 cd ${BUILDDIR}
254 echo "* most suckless software product ever" > FEATURES
255 test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date +%Y)" > debian/copyright
256 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low
257
258 * Initial release
259
260 -- Joe Sixpack <joe@example.org> $(date -R)" > debian/changelog
261 test -e debian/control || echo "Source: $NAME
262 Section: $SECTION
263 Priority: optional
264 Maintainer: Joe Sixpack <joe@example.org>
265 Build-Depends: debhelper (>= 7)
266 Standards-Version: 3.9.1
267
268 Package: $NAME" > debian/control
269 if [ "$ARCH" = 'all' ]; then
270 echo "Architecture: all" >> debian/control
271 else
272 echo "Architecture: any" >> debian/control
273 fi
274 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
275 if [ -z "$DESCRIPTION" ]; then
276 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
277 If you find such a package installed on your system,
278 YOU did something horribly wrong! They are autogenerated
279 und used only by testcases for APT and surf no other propose…" >> debian/control
280 else
281 echo "Description: $DESCRIPTION" >> debian/control
282 fi
283 test -e debian/compat || echo "7" > debian/compat
284 test -e debian/source/format || echo "3.0 (native)" > debian/source/format
285 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
286 cd - > /dev/null
287 }
288
289 buildsimplenativepackage() {
290 local NAME="$1"
291 local ARCH="$2"
292 local VERSION="$3"
293 local RELEASE="${4:-unstable}"
294 local DEPENDENCIES="$5"
295 local DESCRIPTION="$6"
296 local SECTION="${7:-others}"
297 local PRIORITY="${8:-optional}"
298 local DISTSECTION
299 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
300 DISTSECTION="main"
301 else
302 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
303 fi
304 local BUILDDIR=${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}
305
306 msgninfo "Build package ${NAME} in ${VERSION} for ${RELEASE} in ${DISTSECTION}"
307 mkdir -p $BUILDDIR/debian/source
308 echo "* most suckless software product ever" > ${BUILDDIR}/FEATURES
309 echo "#!/bin/sh
310 echo '$NAME says \"Hello!\"'" > ${BUILDDIR}/${NAME}
311
312 echo "Copyleft by Joe Sixpack $(date +%Y)" > ${BUILDDIR}/debian/copyright
313 echo "$NAME ($VERSION) $RELEASE; urgency=low
314
315 * Initial release
316
317 -- Joe Sixpack <joe@example.org> $(date -R)" > ${BUILDDIR}/debian/changelog
318 echo "Source: $NAME
319 Section: $SECTION
320 Priority: $PRIORITY
321 Maintainer: Joe Sixpack <joe@example.org>
322 Standards-Version: 3.9.3" > ${BUILDDIR}/debian/control
323 local BUILDDEPS="$(echo "$DEPENDENCIES" | grep '^Build-')"
324 test -z "$BUILDDEPS" || echo "$BUILDDEPS" >> ${BUILDDIR}/debian/control
325 echo "
326 Package: $NAME" >> ${BUILDDIR}/debian/control
327
328 if [ "$ARCH" = 'all' ]; then
329 echo "Architecture: all" >> ${BUILDDIR}/debian/control
330 else
331 echo "Architecture: any" >> ${BUILDDIR}/debian/control
332 fi
333 local DEPS="$(echo "$DEPENDENCIES" | grep -v '^Build-')"
334 test -z "$DEPS" || echo "$DEPS" >> ${BUILDDIR}/debian/control
335 if [ -z "$DESCRIPTION" ]; then
336 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
337 If you find such a package installed on your system,
338 YOU did something horribly wrong! They are autogenerated
339 und used only by testcases for APT and surf no other propose…" >> ${BUILDDIR}/debian/control
340 else
341 echo "Description: $DESCRIPTION" >> ${BUILDDIR}/debian/control
342 fi
343
344 echo '3.0 (native)' > ${BUILDDIR}/debian/source/format
345 (cd ${BUILDDIR}/..; dpkg-source -b ${NAME}-${VERSION} 2>&1) | sed -n 's#^dpkg-source: info: building [^ ]\+ in ##p' \
346 | while read SRC; do
347 echo "pool/${SRC}" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist
348 # if expr match "${SRC}" '.*\.dsc' >/dev/null 2>&1; then
349 # gpg --yes --no-default-keyring --secret-keyring ./keys/joesixpack.sec \
350 # --keyring ./keys/joesixpack.pub --default-key 'Joe Sixpack' \
351 # --clearsign -o "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC"
352 # mv "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC"
353 # fi
354 done
355
356 for arch in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do
357 rm -rf ${BUILDDIR}/debian/tmp
358 mkdir -p ${BUILDDIR}/debian/tmp/DEBIAN ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME} ${BUILDDIR}/debian/tmp/usr/bin
359 cp ${BUILDDIR}/debian/copyright ${BUILDDIR}/debian/changelog ${BUILDDIR}/FEATURES ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}
360 cp ${BUILDDIR}/${NAME} ${BUILDDIR}/debian/tmp/usr/bin/${NAME}-${arch}
361 (cd ${BUILDDIR}; dpkg-gencontrol -DArchitecture=$arch)
362 (cd ${BUILDDIR}/debian/tmp; md5sum $(find usr/ -type f) > DEBIAN/md5sums)
363
364 dpkg-deb --build ${BUILDDIR}/debian/tmp ${BUILDDIR}/.. 2> /dev/null > /dev/null
365 echo "pool/${NAME}_${VERSION}_${arch}.deb" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.pkglist
366 done
367
368 mkdir -p ${BUILDDIR}/../${NAME}_${VERSION}
369 cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}/
370 cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}.changelog
371 rm -rf "${BUILDDIR}"
372 msgdone "info"
373 }
374
375 buildpackage() {
376 local BUILDDIR=$1
377 local RELEASE=$2
378 local SECTION=$3
379 local ARCH=$(getarchitecture $4)
380 msgninfo "Build package $(echo "$BUILDDIR" | grep -o '[^/]*$') for ${RELEASE} in ${SECTION}… "
381 cd $BUILDDIR
382 if [ "$ARCH" = "all" ]; then
383 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
384 fi
385 local BUILT="$(dpkg-buildpackage -uc -us -a$ARCH 2> /dev/null)"
386 local PKGS="$( echo "$BUILT" | grep '^dpkg-deb: building package' | cut -d'/' -f 2 | sed -e "s#'\.##")"
387 local SRCS="$( echo "$BUILT" | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
388 cd - > /dev/null
389 for PKG in $PKGS; do
390 echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist
391 done
392 for SRC in $SRCS; do
393 echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist
394 done
395 msgdone "info"
396 }
397
398 buildaptarchive() {
399 if [ -d incoming ]; then
400 buildaptarchivefromincoming $*
401 else
402 buildaptarchivefromfiles $*
403 fi
404 }
405
406 createaptftparchiveconfig() {
407 local ARCHS="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb$#\1#' | tr '\n' ' ')"
408 if [ -z "$ARCHS" ]; then
409 # the pool is empty, so we will operate on faked packages - let us use the configured archs
410 ARCHS="$(getarchitectures)"
411 fi
412 echo -n 'Dir {
413 ArchiveDir "' >> ftparchive.conf
414 echo -n $(readlink -f .) >> ftparchive.conf
415 echo -n '";
416 CacheDir "' >> ftparchive.conf
417 echo -n $(readlink -f ..) >> ftparchive.conf
418 echo -n '";
419 FileListDir "' >> ftparchive.conf
420 echo -n $(readlink -f pool/) >> ftparchive.conf
421 echo -n '";
422 };
423 Default {
424 Packages::Compress ". gzip bzip2 lzma xz";
425 Sources::Compress ". gzip bzip2 lzma xz";
426 Contents::Compress ". gzip bzip2 lzma xz";
427 Translation::Compress ". gzip bzip2 lzma xz";
428 LongDescription "false";
429 };
430 TreeDefault {
431 Directory "pool/";
432 SrcDirectory "pool/";
433 };
434 APT {
435 FTPArchive {
436 Release {
437 Origin "joesixpack";
438 Label "apttestcases";
439 Suite "unstable";
440 Description "repository with dummy packages";
441 Architectures "' >> ftparchive.conf
442 echo -n "$ARCHS" >> ftparchive.conf
443 echo 'source";
444 };
445 };
446 };' >> ftparchive.conf
447 for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
448 echo -n 'tree "dists/' >> ftparchive.conf
449 echo -n "$DIST" >> ftparchive.conf
450 echo -n '" {
451 Architectures "' >> ftparchive.conf
452 echo -n "$ARCHS" >> ftparchive.conf
453 echo -n 'source";
454 FileList "' >> ftparchive.conf
455 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
456 echo -n '";
457 SourceFileList "' >> ftparchive.conf
458 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
459 echo -n '";
460 Sections "' >> ftparchive.conf
461 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
462 echo '";
463 };' >> ftparchive.conf
464 done
465 }
466
467 buildaptftparchivedirectorystructure() {
468 local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
469 for DIST in $DISTS; do
470 local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
471 for SECTION in $SECTIONS; do
472 local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
473 for ARCH in $ARCHS; do
474 mkdir -p dists/${DIST}/${SECTION}/binary-${ARCH}
475 done
476 mkdir -p dists/${DIST}/${SECTION}/source
477 mkdir -p dists/${DIST}/${SECTION}/i18n
478 done
479 done
480 }
481
482 insertpackage() {
483 local RELEASE="$1"
484 local NAME="$2"
485 local ARCH="$3"
486 local VERSION="$4"
487 local DEPENDENCIES="$5"
488 local PRIORITY="${6:-optional}"
489 local DESCRIPTION="${7}"
490 local ARCHS=""
491 for arch in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do
492 if [ "$arch" = 'all' -o "$arch" = 'none' ]; then
493 ARCHS="$(getarchitectures)"
494 else
495 ARCHS="$arch"
496 fi
497 for BUILDARCH in $ARCHS; do
498 local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
499 mkdir -p $PPATH aptarchive/dists/${RELEASE}/main/source
500 touch aptarchive/dists/${RELEASE}/main/source/Sources
501 local FILE="${PPATH}/Packages"
502 echo "Package: $NAME
503 Priority: $PRIORITY
504 Section: other
505 Installed-Size: 42
506 Maintainer: Joe Sixpack <joe@example.org>" >> $FILE
507 test "$arch" = 'none' || echo "Architecture: $arch" >> $FILE
508 echo "Version: $VERSION
509 Filename: pool/main/${NAME}/${NAME}_${VERSION}_${arch}.deb" >> $FILE
510 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
511 echo -n 'Description: ' >> $FILE
512 if [ -z "$DESCRIPTION" ]; then
513 echo "an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
514 If you find such a package installed on your system,
515 YOU did something horribly wrong! They are autogenerated
516 und used only by testcases for APT and surf no other propose…" >> $FILE
517 else
518 echo "$DESCRIPTION" >> $FILE
519 fi
520 echo >> $FILE
521 done
522 done
523 }
524
525 insertsource() {
526 local RELEASE="$1"
527 local NAME="$2"
528 local ARCH="$3"
529 local VERSION="$4"
530 local DEPENDENCIES="$5"
531 local ARCHS=""
532 local SPATH="aptarchive/dists/${RELEASE}/main/source"
533 mkdir -p $SPATH
534 local FILE="${SPATH}/Sources"
535 echo "Package: $NAME
536 Binary: $NAME
537 Version: $VERSION
538 Maintainer: Joe Sixpack <joe@example.org>
539 Architecture: $ARCH" >> $FILE
540 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
541 echo "Files:
542 d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.dsc
543 d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.tar.gz
544 " >> $FILE
545 }
546
547 insertinstalledpackage() {
548 local NAME="$1"
549 local ARCH="$2"
550 local VERSION="$3"
551 local DEPENDENCIES="$4"
552 local PRIORITY="${5:-optional}"
553 local STATUS="${6:-install ok installed}"
554 local FILE='rootdir/var/lib/dpkg/status'
555 local INFO='rootdir/var/lib/dpkg/info'
556 for arch in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do
557 echo "Package: $NAME
558 Status: $STATUS
559 Priority: $PRIORITY
560 Section: other
561 Installed-Size: 42
562 Maintainer: Joe Sixpack <joe@example.org>
563 Version: $VERSION" >> $FILE
564 test "$arch" = 'none' || echo "Architecture: $arch" >> $FILE
565 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
566 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/installed
567 If you find such a package installed on your system,
568 YOU did something horribly wrong! They are autogenerated
569 und used only by testcases for APT and surf no other propose…
570 " >> $FILE
571 if [ "$(dpkg-query -W --showformat='${Multi-Arch}')" = 'same' ]; then
572 echo -n > ${INFO}/${NAME}:${arch}.list
573 else
574 echo -n > ${INFO}/${NAME}.list
575 fi
576 done
577 }
578
579
580 buildaptarchivefromincoming() {
581 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
582 cd aptarchive
583 [ -e pool ] || ln -s ../incoming pool
584 [ -e ftparchive.conf ] || createaptftparchiveconfig
585 [ -e dists ] || buildaptftparchivedirectorystructure
586 msgninfo "\tGenerate Packages, Sources and Contents files… "
587 aptftparchive -qq generate ftparchive.conf
588 cd - > /dev/null
589 msgdone "info"
590 generatereleasefiles
591 }
592
593 buildaptarchivefromfiles() {
594 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
595 find aptarchive -name 'Packages' -o -name 'Sources' | while read line; do
596 msgninfo "\t${line} file… "
597 cat ${line} | gzip > ${line}.gz
598 cat ${line} | bzip2 > ${line}.bz2
599 cat ${line} | xz --format=lzma > ${line}.lzma
600 cat ${line} | xz > ${line}.xz
601 msgdone "info"
602 done
603 generatereleasefiles
604 }
605
606 # can be overridden by testcases for their pleasure
607 getcodenamefromsuite() { echo -n "$1"; }
608 getreleaseversionfromsuite() { true; }
609 getlabelfromsuite() { true; }
610
611 generatereleasefiles() {
612 # $1 is the Date header and $2 is the ValidUntil header to be set
613 # both should be given in notation date/touch can understand
614 msgninfo "\tGenerate Release files… "
615 if [ -e aptarchive/dists ]; then
616 for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
617 local SUITE="$(echo "$dir" | cut -d'/' -f 4)"
618 local CODENAME="$(getcodenamefromsuite $SUITE)"
619 local VERSION="$(getreleaseversionfromsuite $SUITE)"
620 local LABEL="$(getlabelfromsuite $SUITE)"
621 if [ -n "$VERSION" ]; then
622 VERSION="-o APT::FTPArchive::Release::Version=${VERSION}"
623 fi
624 if [ -n "$LABEL" ]; then
625 LABEL="-o APT::FTPArchive::Release::Label=${LABEL}"
626 fi
627 aptftparchive -qq release $dir \
628 -o APT::FTPArchive::Release::Suite="${SUITE}" \
629 -o APT::FTPArchive::Release::Codename="${CODENAME}" \
630 ${LABEL} \
631 ${VERSION} \
632 | sed -e '/0 Release$/ d' > $dir/Release # remove the self reference
633 if [ "$SUITE" = "experimental" -o "$SUITE" = "experimental2" ]; then
634 sed -i '/^Date: / a\
635 NotAutomatic: yes' $dir/Release
636 fi
637 if [ -n "$1" -a "$1" != "now" ]; then
638 sed -i "s/^Date: .*$/Date: $(date -d "$1" '+%a, %d %b %Y %H:%M:%S %Z')/" $dir/Release
639 fi
640 if [ -n "$2" ]; then
641 sed -i "/^Date: / a\
642 Valid-Until: $(date -d "$2" '+%a, %d %b %Y %H:%M:%S %Z')" $dir/Release
643 fi
644 done
645 else
646 aptftparchive -qq release ./aptarchive | sed -e '/0 Release$/ d' > aptarchive/Release # remove the self reference
647 fi
648 if [ -n "$1" -a "$1" != "now" ]; then
649 for release in $(find ./aptarchive -name 'Release'); do
650 touch -d "$1" $release
651 done
652 fi
653 msgdone "info"
654 }
655
656 setupdistsaptarchive() {
657 local APTARCHIVE=$(readlink -f ./aptarchive)
658 rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list
659 rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list
660 for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
661 SECTIONS=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
662 msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
663 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list
664 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list
665 msgdone "info"
666 done
667 }
668
669 setupflataptarchive() {
670 local APTARCHIVE=$(readlink -f ./aptarchive)
671 if [ -f ${APTARCHIVE}/Packages ]; then
672 msgninfo "\tadd deb sources.list line… "
673 echo "deb file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
674 msgdone "info"
675 else
676 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
677 fi
678 if [ -f ${APTARCHIVE}/Sources ]; then
679 msgninfo "\tadd deb-src sources.list line… "
680 echo "deb-src file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
681 msgdone "info"
682 else
683 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
684 fi
685 }
686
687 setupaptarchive() {
688 buildaptarchive
689 if [ -e aptarchive/dists ]; then
690 setupdistsaptarchive
691 else
692 setupflataptarchive
693 fi
694 signreleasefiles
695 if [ "$1" != '--no-update' ]; then
696 msgninfo "\tSync APT's cache with the archive… "
697 aptget update -qq
698 msgdone "info"
699 fi
700 }
701
702 signreleasefiles() {
703 local SIGNER="${1:-Joe Sixpack}"
704 msgninfo "\tSign archive with $SIGNER key… "
705 local SECKEYS=""
706 for KEY in $(find keys/ -name '*.sec'); do
707 SECKEYS="$SECKEYS --secret-keyring $KEY"
708 done
709 local PUBKEYS=""
710 for KEY in $(find keys/ -name '*.pub'); do
711 PUBKEYS="$PUBKEYS --keyring $KEY"
712 done
713 for RELEASE in $(find aptarchive/ -name Release); do
714 gpg --yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" -abs -o ${RELEASE}.gpg ${RELEASE}
715 gpg --yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" --clearsign -o "$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')" $RELEASE
716 done
717 msgdone "info"
718 }
719
720 changetowebserver() {
721 local LOG='/dev/null'
722 if test -x ${BUILDDIRECTORY}/aptwebserver; then
723 cd aptarchive
724 LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/aptwebserver "$@" >$LOG 2>&1 &
725 addtrap "kill $!;"
726 cd - > /dev/null
727 elif [ $# -gt 0 ]; then
728 msgdie 'Need the aptwebserver when passing arguments for the webserver'
729 elif which weborf > /dev/null; then
730 weborf -xb aptarchive/ >$LOG 2>&1 &
731 addtrap "kill $!;"
732 elif which gatling > /dev/null; then
733 cd aptarchive
734 gatling -p 8080 -F -S >$LOG 2>&1 &
735 addtrap "kill $!;"
736 cd - > /dev/null
737 elif which lighttpd > /dev/null; then
738 echo "server.document-root = \"$(readlink -f ./aptarchive)\"
739 server.port = 8080
740 server.stat-cache-engine = \"disable\"" > lighttpd.conf
741 lighttpd -t -f lighttpd.conf >/dev/null || msgdie 'Can not change to webserver: our lighttpd config is invalid'
742 lighttpd -D -f lighttpd.conf >$LOG 2>&1 &
743 addtrap "kill $!;"
744 else
745 msgdie 'You have to build aptwerbserver or install a webserver'
746 fi
747 local APTARCHIVE="file://$(readlink -f ./aptarchive)"
748 for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
749 sed -i $LIST -e "s#$APTARCHIVE#http://localhost:8080/#"
750 done
751 return 0
752 }
753
754 changetocdrom() {
755 mkdir -p rootdir/media/cdrom/.disk
756 local CD="$(readlink -f rootdir/media/cdrom)"
757 echo "acquire::cdrom::mount \"${CD}\";" > rootdir/etc/apt/apt.conf.d/00cdrom
758 echo 'acquire::cdrom::autodetect 0;' >> rootdir/etc/apt/apt.conf.d/00cdrom
759 echo -n "$1" > ${CD}/.disk/info
760 if [ ! -d aptarchive/dists ]; then
761 msgdie 'Flat file archive cdroms can not be created currently'
762 return 1
763 fi
764 mv aptarchive/dists $CD
765 ln -s "$(readlink -f ./incoming)" $CD/pool
766 find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list' -delete
767 }
768
769 checkdiff() {
770 local DIFFTEXT="$($(which diff) -u $* | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
771 if [ -n "$DIFFTEXT" ]; then
772 echo
773 echo "$DIFFTEXT"
774 return 1
775 else
776 return 0
777 fi
778 }
779
780 testfileequal() {
781 local FILE="$1"
782 shift
783 msgtest "Test for correctness of file" "$FILE"
784 if [ -z "$*" ]; then
785 echo -n "" | checkdiff $FILE - && msgpass || msgfail
786 else
787 echo "$*" | checkdiff $FILE - && msgpass || msgfail
788 fi
789 }
790
791 testempty() {
792 msgtest "Test for no output of" "$*"
793 test -z "$($* 2>&1)" && msgpass || msgfail
794 }
795
796 testequal() {
797 local COMPAREFILE=$(mktemp)
798 addtrap "rm $COMPAREFILE;"
799 echo "$1" > $COMPAREFILE
800 shift
801 msgtest "Test for equality of" "$*"
802 $* 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
803 }
804
805 testequalor2() {
806 local COMPAREFILE1=$(mktemp)
807 local COMPAREFILE2=$(mktemp)
808 local COMPAREAGAINST=$(mktemp)
809 addtrap "rm $COMPAREFILE1 $COMPAREFILE2 $COMPAREAGAINST;"
810 echo "$1" > $COMPAREFILE1
811 echo "$2" > $COMPAREFILE2
812 shift 2
813 msgtest "Test for equality OR of" "$*"
814 $* 2>&1 1> $COMPAREAGAINST
815 (checkdiff $COMPAREFILE1 $COMPAREAGAINST 1> /dev/null ||
816 checkdiff $COMPAREFILE2 $COMPAREAGAINST 1> /dev/null) && msgpass ||
817 ( echo "\n${CINFO}Diff against OR 1${CNORMAL}" "$(checkdiff $COMPAREFILE1 $COMPAREAGAINST)" \
818 "\n${CINFO}Diff against OR 2${CNORMAL}" "$(checkdiff $COMPAREFILE2 $COMPAREAGAINST)" &&
819 msgfail )
820 }
821
822 testshowvirtual() {
823 local VIRTUAL="N: Can't select versions from package '$1' as it is purely virtual"
824 local PACKAGE="$1"
825 shift
826 while [ -n "$1" ]; do
827 VIRTUAL="${VIRTUAL}
828 N: Can't select versions from package '$1' as it is purely virtual"
829 PACKAGE="${PACKAGE} $1"
830 shift
831 done
832 msgtest "Test for virtual packages" "apt-cache show $PACKAGE"
833 VIRTUAL="${VIRTUAL}
834 N: No packages found"
835 local COMPAREFILE=$(mktemp)
836 addtrap "rm $COMPAREFILE;"
837 local ARCH="$(getarchitecture 'native')"
838 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
839 aptcache show -q=0 $PACKAGE 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
840 }
841
842 testnopackage() {
843 msgtest "Test for non-existent packages" "apt-cache show $*"
844 local SHOWPKG="$(aptcache show $* 2>&1 | grep '^Package: ')"
845 if [ -n "$SHOWPKG" ]; then
846 echo
847 echo "$SHOWPKG"
848 msgfail
849 return 1
850 fi
851 msgpass
852 }
853
854 testdpkginstalled() {
855 msgtest "Test for correctly installed package(s) with" "dpkg -l $*"
856 local PKGS="$(dpkg -l $* 2>/dev/null | grep '^i' | wc -l)"
857 if [ "$PKGS" != $# ]; then
858 echo $PKGS
859 dpkg -l $* | grep '^[a-z]'
860 msgfail
861 return 1
862 fi
863 msgpass
864 }
865
866 testdpkgnotinstalled() {
867 msgtest "Test for correctly not-installed package(s) with" "dpkg -l $*"
868 local PKGS="$(dpkg -l $* 2> /dev/null | grep '^i' | wc -l)"
869 if [ "$PKGS" != 0 ]; then
870 echo
871 dpkg -l $* | grep '^[a-z]'
872 msgfail
873 return 1
874 fi
875 msgpass
876 }
877
878 testmarkedauto() {
879 local COMPAREFILE=$(mktemp)
880 addtrap "rm $COMPAREFILE;"
881 if [ -n "$1" ]; then
882 msgtest 'Test for correctly marked as auto-installed' "$*"
883 while [ -n "$1" ]; do echo "$1"; shift; done | sort > $COMPAREFILE
884 else
885 msgtest 'Test for correctly marked as auto-installed' 'no package'
886 echo -n > $COMPAREFILE
887 fi
888 aptmark showauto 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
889 }
890
891 pause() {
892 echo "STOPPED execution. Press enter to continue"
893 local IGNORE
894 read IGNORE
895 }